package com.cf.imes.module.system.api.machine;

import com.cf.imes.framework.common.pojo.CommonResult;
import com.cf.imes.framework.common.util.json.JsonUtils;
import com.cf.imes.framework.common.util.object.BeanUtils;
import com.cf.imes.module.system.api.machine.dto.CuttingRespDTO;
import com.cf.imes.module.system.api.machine.dto.MachineDTO;
import com.cf.imes.module.system.controller.admin.label.vo.LabelRespVO;
import com.cf.imes.module.system.controller.admin.machine.vo.CuttingRespVO;
import com.cf.imes.module.system.service.lable.LabelService;
import com.cf.imes.module.system.service.machine.MachineService;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;

import java.util.Collection;
import java.util.List;

import static com.cf.imes.framework.common.pojo.CommonResult.success;

@RestController // 提供 RESTful API 接口，给 Feign 调用
@Validated
public class MachineApiImpl implements MachineApi {

    @Resource
    private MachineService machineService;

    @Resource
    private LabelService labelService;

    @Override
    public CommonResult<CuttingRespDTO> getCutting(Long id) {
        return success(BeanUtils.toBean(machineService.getCutting(id), CuttingRespDTO.class));
    }

    @Override
    public CommonResult<CuttingRespDTO> getDrill(Long id) {
        return success(BeanUtils.toBean(machineService.getDrill(id), CuttingRespDTO.class));
    }

    @Override
    public CommonResult<List<CuttingRespDTO>> list(Collection<Long> ids) {
        return success(BeanUtils.toBean(machineService.list(ids), CuttingRespDTO.class));
    }

    @Override
    public CommonResult<MachineDTO> getMachineDetail(Long id) {
        CuttingRespVO cutting = machineService.getCutting(id);
        LabelRespVO label = labelService.getLabel(cutting.getLabelId());
        MachineDTO machineDTO = MachineDTO.builder()
                .id(cutting.getId())
                .machineType(cutting.getMachineType())
                .name(cutting.getName())
                .setting(cutting.getMachineSettingDO().toJSONString())
                .label(JsonUtils.toJsonString(label))
                .build();
        return success(machineDTO);
    }
}
